<html>
<head>
<title>
Cours de Compilation - FAQ</title>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">
<style>
em {color: #FFA0B0}
pre {color: #F0F0FF; font-family: courier; font-size:18pt;}
tt {color: #F0F0FF}
.vt {font-weight: bold; color: #70FF70}
.ib {font-weight: bold; font-style: italic}

</style>
</head>

<BODY BACKGROUND="" BGCOLOR="#002060" TEXT="#ffffa0" LINK="#80ff00" VLINK="#ff80c0" ALINK="#ff0000">
<P>

<center>
<h1>
Cours de Compilation - Foire Aux Questions
</h1>
</center>
<p>

Ceci est la page 1. La continuation se trouve ici :
<a href="quest2.html"><span class="vt">FAQ, page 2.</span></a>
<p>

<dl>
<dt>
<span class=vt>Mickaël Lelong :</span> 
J'aimerais faire des boucles en Haskell et génèralement -
faire une version itérative d'une procédure récursive terminale faite en Haskell. 
Cela éviterait  N appels récursifs à la fonction, meme si Haskell est un 
langage fonctionnel, je pense qu'ici une boucle serait plus appropriée (CAML 
par exemple permet d'écrire en itératif même si ce n'est pas sa fonction 
première).
<p>
<dd>
Écoutez <b>je vous assure !</b> :
Dans un langage fonctionnel moderne, y compris Scheme, Caml et Haskell,
il n'y a aucune pénalité liée aux "appels récursifs" terminaux. Ceci
<b>est</b> transformé internement en boucle. Je dirai plus, en Scheme toute
boucle (while, for) n'est rien d'autre, qu'une macro qui se transforme
en un objet fonctionnel récursif terminal.
<p>

C'est un peu paradoxal : On fait des boucles, pour que le préprocesseur
les transforme en <i>tail-recursion</i>, pour que le générateur de code de
bas niveau les transforme en boucles style assembleur. Mais c'est comme 
ça, et ceci est la façon la plus modulaire et sécuritaire de faire ça.
<p>

Les "vraies" boucles sont <em>des structures impératives</em>, elles 
<b>doivent</b>
générer les effets de bord, modifier la variable de contrôle et autres
variables, tandis que - comme vous le savez - la forme itérative
fonctionnelle passe à un nouveau jeu de paramètres. C'est plus compact.
<p>
<hr>
<p>

<dt>
<span class=vt>F. Dembri : </span>
Pourquoi ne pas construire un compilateur tatalement hybride ?
Hybride dans le sens ou on peut faire du fonctionnel, de l'objet, du logique...
et ceci en intégrant une syntaxe hybride. Un langage de la forme:<p>
<pre>
typeLanguage functionnel
(defun ...)
(setq ..)
..
typeLanguage logical
..
typeLanguage Object
MyObject.Affiche ( )
</pre>
Et ou chaque pseudo-langage pourrait être pur (soit tout objet, soit
fonctionnel pur..) ou pas. L'idée est que souvent on a à choisir un
langage pour implémenter tel ou tel problème; assez souvent nous
aimerions simplement (c'est peut-etre un besoin!) avoir plusieurs
couches de langages différents, avoir la possibilité "d'hybrider"!
Attention le but n'est pas à priori un "hybridage" de langages, mais de
types de langages! (meme si l'exemple dit plutot le contraire)
<p>

<dd>
Le problème est complexe, et persistant à travers <b>toutes</b> les catégories
de l'organisation de notre pensée, activité ou société : <i><b>diversifier</b>, 
faire
de la morphogénèse, de la spécialisation, ce qui modularise le monde et
permet de faire des constructions plus efficaces, ou, à l'envers, <b>intégrer</b>,
chercher les points communs, hybrider, métisser, ce qui génère les organismes
"bâtards", normalement plus universels et résistants ...?</i>
<p>
La réponse universelle n'existe pas. Le type du langage c'est son style de
programmation, et <i>normalement</i> le style doit être homogène, sinon c'est
de la pagaille. De plus, si la syntaxe de ces couches hétérogènes est si
différente, comme sur votre exemple, je ne peux vraiment imaginer que quelqu'un
puisse vouloir utiliser simultanément plusieurs couches. 
La sémantique doit être
homogène aussi. Un module fonctionnel où on infiltre les effets de bord
de nature impérative c'est l'invitation à des bugs de pire espèce.
Donc, la tendance de faire des langages et les compilateurs "propres" est
visible. Même dans le domaine de "number crunching" - la programmation
scientifique, où les gens demandent de la puissance brute et utilisent "C"
ou Fortran, la nécessité d'utiliser quelques techniques fonctionnelles est
visible, et on invente des langages appropriés, comme Sisal, ou lieu de
hybrider Fortran (ce serait de la pornographie ...).
<p>

Veut-on de la programmation logique dans ce contexte? Pourquoi pas, il
faut prendre un langage bien compilé et typé, pour éviter le décodage
dynamique des termes (ce qui ralentit Prolog). Cela existe, par exemple
Mercury.

<p>

Et même dans le domaine "objet", on voit une prolifération de sous-styles.
Les fonctions génériques de Common Lisp n'ont pas beaucoup de commun avec
les messages de Smalltalk. C++ et Java sont différents: héritage multiple
ici, le concept d'interfaces là, etc. Eiffel est encore un peu différent.
Si vous mélangez tout ensemble, ce sera monstrueux.
<p>

D'autre part, faire des petits modules / procédures / structures de données
appartenant aux "ethnies" différentes dans le même programme, mais qui
reste relativement "artistiquement pur", peut être avantageux, car facilite
l'exploitation de plusieurs techniques de programmation. Oui, ça existe
l'hybridation, et depuis longtemps. Rappelons-nous que le système à objets
CLOS est bâti sur la couche fonctionnelle du Common Lisp, à laquelle on a 
ajouté des éléments OO (et impératives...).
<p>

Les langages fonctionellogiques prolifèrent : Life, Oz, etc. Le monde Prolog
a redécouvert les monades, concept par excellence fonctionnel. Python qui
était un petit langage orienté-objet maintenant permet d'utiliser quelques
techniques fonctionnelles.
<p>

Haskell et Clean qui sont des langages fonctionnels purs gérent le 
polymorphisme par la catégorie de <i>classes de types</i>, ce qui a un
goût typiquement OO. Finalement, Objective CAML est un langage hybride, de
préférence fonctionnel, mais avec de l'impératif contrôlé et discipliné,
et une petite couche à objets.<p>

Bref, tout est possible, mais il faut rester calme. Faire un supercompilateur
capable de manipuler des concepts très hétérogènes est une tâche difficile,
le résultat serait lourd, et on ne pourrait pas espérer des miracles 
d'efficacité - normalement les hybrides sont <i>très</i> difficiles à
optimiser.
<p>

<em>(Je n'ai pas beaucoup de temps, mais si vous voulez quelques références
Internet sur les langages de programmation en général, essayez de me harceler
avec une certaine insistance, finalement je vous trouverai quelque chose.)
</em>

<p>
<hr>
<p>


<dt>
<span class=vt>M. LeLong : </span>
Il y a ... quelque chose que je comprends pas : Show est defini en utilisant 
showsPrec et reciproquement. dans le prelude standard, a savoir
<P>
<pre>
 class Show a where
     show      :: a -&gt; String
     showsPrec :: Int -&gt; a -&gt; ShowS
     showList  :: [a] -&gt; ShowS
 
     -- Minimal complete definition: show or showsPrec
     show x          = showsPrec 0 x ""
     showsPrec _ x s = show x ++ s
     showList []     = showString "[]"
     showList (x:xs) = showChar '[' . shows x . showl xs
                       where showl []     = showChar ']'
                             showl (x:xs) = showChar ',' . shows x . showl xs
</pre>
<p>
<dd>

Voilà une question à laquelle la réponse est déjà indispensable, mais qui sera abordée
un peu plus tard ...: Comment définir, et comment implanter les fonctions surchargés?
Ceci touche un peu la philosophie de programmation orientée-objet.
 <p>

Nous connaissons tous les opérateurs surchargés ; le cas un peu trivial en "C" avec le
"même" <tt>(+)</tt> pour les entiers et les flottants, ainsi que toute l'usine à gaz
de surcharge (fonctions génériques) en "C++". Je vous ai mentionné qu'en Haskell on
peut surcharger les fonctions et les opérateurs aussi, et nous avons défini l'égalité
pour les objets de type <tt>Value</tt>, etc. En réalité on ne peut tout simplement
pas écrire "<tt>F x == F y = x==y</tt>". <em>Il faut déclarer que le type <tt>Value</tt>
est une instance de la classe <tt>Eq</tt>. Une <span class="vt">classe</span> est une
famille de types qui admet l'existence de certaines fonctions (méthodes, si vous
voulez, mais le mot n'est pas utilisé).</em> Ce n'est pas du C++, une donnée (un objet)
n'appartient pas à une classe. Son <b>type</b>, si ! (éventuellement), et c'est ça la
déclaration de l'instance.
<p>

Vous définissez les fonctions surchargées à l'intérieur <em>des instances</em>. Or,
M. LeLong nous a montre un contre-exemple, la définition concrète de <tt>show</tt>
(qui est la fonction d'interfaçage standard) et de <tt>showsPrec</tt> (le moteur de
base, capable de faire l'"anti-parsing" et de réconstruire les expressions avec les
opérateurs infixes). De plus, ces deux définitions sont un peu "bidon", car elles
se référencent réciproquement.
<p>

Il faut donc savoir, que ce sont des définitions <em>par défaut</em>, qui normalement
sont remplacées par les définitions dans les instances. Leur rôle est d'éviter
que l'utilisateur soit obligé de répéter maintes fois les mêmes relations triviales.
Ici, pour chaque type "imprimable", qui appartient à <tt>Show</tt>, le programmeur
doit rédéfinir soit <tt>show</tt>, soit <tt>showsPrec</tt>, ou les deux, mais 
obligatoirement au moins une de ces fonctions.
<p>

De telles définitions par défaut sont abondantes. par exemple, on peut définir la
multiplication d'un x quelconque par un nombre entier n comme n*x = x+x+x+ ...
<p>
Ou, définir x/y comme x*(recip y), et simultanément recip x = 1/x. Pour chaque type
concret il faudra remplacer une de ces définitions par quelque chose autonôme.
<p>

L'implantation des classes, l'usage des dictionnaires (tableaux de fonctions
virtuelles) etc. sera abordé plus tard.

<p>
<hr>
<p>

<dt>
<span class=vt>Mickaël Lelong :</span> 
J'ai essayé quelques trucs en haskell, mais je rencontre quelques
problemes de typage dont certains restent a ce jour non résolus, donc je me
tourne vers le dernier recours, a savoir vous.
<p>
<dd>
Ben,..., merci. Hm,hm. Je ne veux pas vous vexer, mais il existe toujours la documentation, je ne suis pas le "dernier" recours. Ceci dit, voici mon commentaire.
<p>

<dt>
<TT>many2</TT> qui avance dans le flot d'entrée sans conserver les resultats provoque une erreur :
<PRE>
many2 p = p &gt;&gt; many2p p 
many2p p = (p &gt;&gt; many2p p) # return []
blanks2 = many2p  (literal ' ')

--Type checking      
--ERROR "parser.hs" (line 85): Unresolved top-level overloading
--*** Binding             : blanks2
--*** Outstanding context : Eq b
</PRE>
<dd>
C'est un excellent exemple, merci ! C'est une boîte de Pandore, d'ailleurs, alors préparez-vous à un commentaire assez long.
<p>

Vous pouvez vérifier que <TT>many2</TT> passe par le compilateur, mais <TT>blanks2</TT>, qui concrétise l'itérateur en lui passant l'argument <TT>(literal ' ')</TT>, pourtant parfaitement légal - explose au niveau du vérificateur de types. La raison est la suivante : Haskell est un langage polymorphe, c'est à dire il permet de définir les fonctions agissant sur les structures dont le contenu peut appartenir à un type quelconque. Vous pouvez définir le carré comme <TT>sqr x = x*x</TT>, et ceci devrait marcher pour tous les nombres et autres structures algébriques. Mais si vous définissez un <EM>objet</EM>, et non pas une fonction : <TT>obj = ... </TT>, le système veut qu'il soit "concret". Si <TT>obj</TT> en réalité est une fonction : <TT>obj = \x -&gt; ...</TT> il existe une restriction pénible : cette fonction doit être <I>monomorphe</I>, son type doit être concret. Alors, si vous écrivez le code suivant :
<PRE>
dblop f x = f x x
sqr = dblop (*)
</PRE>
le système est "coincé". L'objet <TT>sqr</TT> étant "top level" ne peut pas être polymorphe. Mais il "ne sait pas" quelle multiplication utiliser, entière, flottante ou autre ! Dans ce cas (c'est une convention arbitraire de la part des auteurs) Hugs 98 considère <SPAN class=ib>par défaut</SPAN> que <TT>(*)</TT> est une application <TT>Integer -&gt; Integer -&gt; Integer</TT>, et <TT>sqr 2.3</TT> bombe. Mais la définition <TT>sqr2 x = dblop (*) x</TT> reste parfaitement polymorphe et applicable aux entiers, ainsi qu'aux flottants. Je vous ai dit que l'ordre normal d'évaluation vous permet de simplifier <TT>f x = g x</TT> par <TT>f = g</TT>, mais je vous ai averti que le vérificateur de types peut attribuer à <TT>f</TT> un autre type, que cette simplification n'est pas complètement transparente. Maintenant vous savez pourquoi.
<p>

Parfois la restriction monomorphique n'a aucune chance d'être automatisé "par défaut" (qui marche seulement avec les nombres). Comparez ces deux définitions :
<PRE>
fc x y | x==y = x
       | otherwise = []

fc1 = \x y -&gt; if x==y then x else []
</PRE>
La première est impeccable, l'appel à <TT>fc</TT> doit seulement assurer que <TT>x, y</TT> sont des listes. La seconde bombe :
<PRE>
Type checking
ERROR "Mtest.hs" (line 4): Unresolved top-level overloading
*** Binding             : fc1
*** Outstanding context : Eq b
</PRE>
Le résultat éventuel <TT>[]</TT> reste polymorphe (c'est une exception à la règle qu'il n'y ait pas des constantes polymorphes. La liste vide peut être de type quelconque.)
Mais ceci n'implique rien pour <TT>x</TT>. Donc, le système ne sait pas comment compiler <TT>x==y</TT> ! Et il rale, en précisant qu'il faut définir d'abord l'égalité.
<p>
Il y a deux solutions ici. La première est très simple, vous ajoutez le monomorphisme à la main, par exemple : <TT>fc1 = \x y -&gt; if x==y then x else ""</TT>. Ainsi le type de <TT>x</TT> devient <TT>[Char]</TT>, et tout est cuit.
<p>
<EM>Ceci est la solution de votre problème ! Ne retournez pas de <TT>many2p</TT> la liste vide, en tout cas vous n'en avez pas besoin. Retournez un objet monomorphe "bidon", par exemple <TT>()</TT></EM>.
<p>

Une deuxième solution est possible, mais elle est un peu exotique. Même avec le système de typage statique, Haskell permet d'effectuer la <SPAN class=ib>liaison dynamique</SPAN> entre les arguments et leurs "méthodes de traitement". Il faut dire au système : <SPAN class=ib>Désolé, mon vieux, mais je ne veux pas fixer le type de <TT>x</TT> ni <TT>y</TT> maintenant. Cependant, je t'assure que tout appel de <TT>fc1</TT> sera parfaitement en règle avec la fiscalité. Les arguments vont appartenir à un type qui instancie la classe <TT>Eq</TT>, où <TT>(==)</TT> est défini</SPAN>. Il faudra définir notre fonction comme
<PRE>
fc1 :: Eq a =&gt; [a]-&gt;[a]-&gt;[a]
fc1 = \x y -&gt; if x==y then x else []
</PRE>
et cela fonctionne. 
Mais la compilation de <TT>fc1</TT> devient plus compliquée. Cette fonction prend un argument "caché", totalement invisible, et cet argument est un <EM>dictionnaire</EM>. Dans ce dictionnaire la fonction cherche la définition de l'opérateur <TT>(==).</TT> La génération du code pour <TT>fc1 a b</TT> commence par la reconnaissance du type des arguments <TT>a</TT> et <TT>b</TT>. Le compilateur vérifie l'instance <TT>Eq</TT> de ce type. Récupère cette instance <EM>qui est le dictionnaire en question</EM>, et le passe à <TT>fc1</TT>.
<p>

Voilà. Vous avez ici la description d'une technique de compilation de langages à objets, avec les tables de fonctions virtuelles, qui s'appelent ici les dictionnaires d'instances.
<p>

<HR WIDTH="95%" size=6 ALIGN=CENTER><p>

<dt>
Une autre question, parseur des flottants :
<PRE>
decp = chiffre &gt;&gt;= \x -&gt; declist x/10 100
declist x d = (chiffre &gt;&gt;= \y -&gt; 
   declist (x + y/d) (d*10)) # return x

Type checking      
ERROR "parser.hs" (line 105): Instance of Fractional Int required 
   for definition of declist
</PRE>
<p>

<dd>
Ce problème est simple. L'opérateur "/" n'est pas défini pour les entiers, mais pour les types qui appartiennent à la classe <TT>Fractional</TT> : les flottants, les fractions rationnelles, etc.
<p>

Mais si vous écrivez tout simplement <TT>4/6</TT>, le système répond correctement : <TT>0.666666667 :: Double</TT>. Pourquoi?
<p>

Parce que <EM>toute constante numérique explicite</EM>, par exemple "4" est 
<em>surchargée</em>. Elle est
par défaut compilée comme <TT>(fromInt 4)</TT>, et rendue "un peu" polymorphe, surchargée 
au niveau source,
de façon à pouvoir s'adapter au contexte de son usage. Ainsi Haskell réalise la conversion automatique des entiers en flottant, etc. "4/6" marche, même si Haskell ne sait vraiment pas comment concrétiser <TT>(fromInt 4)</TT> etc. la règle par défaut s'applique. Faut-il un objet de la classe <TT>Fractional</TT> ? Ok, pourquoi pas, on vous donne <TT>Double</TT>. Dans l'autre exemple :
<p>
<PRE>
nombre = integ &gt;&gt;= \i -&gt; exposant &gt;&gt;= \(s,e) -&gt; let r = i ^ e in
	case s of
		'+' -&gt; return r
  		'-' -&gt; return (1 / r)
</PRE>
c'est la même chose, la dernière ligne est illégale. <EM>Ajoutez manuellement <TT>fromInt</TT> à toutes les variables qui doivent être converties.</EM> Ici : <TT>r</TT>. Mais faites attention, on ne doit pas retourner soit <TT>r</TT> entier, soit <TT>1/r</TT> flottant. Assurez vous que le résultat soit homogène.
</dl>
<p>

<p>
<hr>
<p>

<p align=right>
<a href="index.html"> 
Retour à la page Maît-compil &nbsp; 
<img src="../icons/gb_lcarb.gif" border=0 align=absmiddle></a>
<p>
<hr><p>

</body>
</html>
